// Keep calm and remember this is requirejs, not dojo!
define(["./Utility",
	"./draglist/DragList",
	"./draglist/DragListNodeLabeledValue",
	"jquery.autocomplete",
	"jquery"
], function (
		utility,
		DragList,
		DragListNodeLabeledValue,
		autoCompleteShim, //do not remove
		$) {

    function sortByValueKey(a, b) {
        var al = a.value.toLocaleLowerCase();
        var bl = b.value.toLocaleLowerCase();
        if (al < bl)
            return -1;
        if (al > bl)
            return 1;
        return 0;
    }
    return utility.createClass(null, {
        constructor: function (extTypo3Version) {
			this.version7 = extTypo3Version.indexOf("7.") === 0;
            this.atlasLocationInput = this.getSettingsInputProxy('settings.atlasLocation');
            this.backendUrlInput = this.getSettingsInputProxy('settings.backendUrl');
            $(this.atlasLocationInput).on('change', this.updateMapStore.bind(this));
            $(this.backendUrlInput).on('change', this.updateMapStore.bind(this));

            var labels = document.querySelectorAll(this.version7 ? '.t3js-formengine-label' : '.t3-form-field-label-flex');
            var headings = [
                'Suchfilter Einstellungen',
                'Konfiguration der Ergebnistabelle'
            ];
            var headingDomNodes = [null, null];
            for (var i = 0; i < labels.length; i++) {
				var text = labels[i].textContent.trim();
                var j = headings.indexOf(text);
                if (j >= 0) {
					var label = $(labels[i]);
					label.css({
						fontWeight: 'bold',
						fontSize: '15px'
					});
					//fixme: pre-version7 classes?
					label.closest('.form-group').css({
						marginBottom: '7px'
					});
					label.closest('.form-section').css({
						background: '#e8e8e8'
					});
                    headingDomNodes[j] = labels[i];
                }
            }
            var headingNodeResultTable = headingDomNodes[1];

            this.errorNode = this.createErrorNode(this.atlasLocationInput.parentElement.parentElement);

            this.map = {
                input: this.getSettingsInput('settings.mapId'),
                inputProxy: this.getSettingsInputProxy('settings.mapId'),
                items: [],
                selectId: "mapIdSearch",
                select: null,
                placeHolder: "Map Suche",
                onChange: this.onMapChange.bind(this)
            };
            this.filterLayer = {
                input: this.getSettingsInput('settings.filterLayerId'),
                inputProxy: this.getSettingsInputProxy('settings.filterLayerId'),
                items: [],
                selectId: "filterLayerIdSearch",
                select: null,
                placeHolder: "Layer Suche",
                onChange: this.onFilterLayerChange.bind(this)
            };
            this.filterField = {
                input: this.getSettingsInput('settings.filterField'),
                inputProxy: this.getSettingsInputProxy('settings.filterField'),
                items: [],
                selectId: "filterFieldSearch",
                select: null,
                placeHolder: "Filter Feld Suche",
                onChange: this.onFilterFieldChange.bind(this)
            };
            this.fieldValues = {
                input: this.getSettingsTextArea('settings.filterValues'),
                possibleText: "Mögliche Werte",
                selectedText: "Ausgewählte Werte"
            };
            this.resultColumns = {
                input: this.getSettingsTextArea('settings.resultColumns'),
				hasWidth: true,
                possibleText: "Mögliche Spalten",
                selectedText: "Ausgewählte Spalten"
            };
            this.manualLayers = {
                input: this.getSettingsTextArea('settings.manualLayers')
            };

            var showFilter = this.getSettingsCheckbox('settings.showFilter');
            var filterText = this.getSettingsInput('settings.filterText');
            this.enableUniqueValueRenderer = this.getSettingsCheckbox('settings.enableUniqueValueRenderer');
            this.enableFilter = this.getSettingsCheckbox('settings.enableFilter');
            var filtersCheckedOnStart = this.getSettingsSelect('settings.filtersCheckedOnStart');
            var enableManualLayers = this.getSettingsCheckbox('settings.enableManualLayers');
            var enableResultTable = this.getSettingsCheckbox('settings.enableResultTable');
            var resultContainerStyle = this.getSettingsInput('settings.resultContainerStyle');
            this.setupMapSelect();
            this.setupManualLayersSelect();
            this.setupFilterLayerSelect();
            this.setupFilterFieldSelect();
            this.setupFilterFieldValuesSelect();
            this.setupResultSelect();
			
			var fieldContainerClass = this.version7 ? 'form-section' : 't3-form-field-container';
            var filterOptions = [
                this.findParentByClass(showFilter, fieldContainerClass),
                this.findParentByClass(filterText, fieldContainerClass),
                this.findParentByClass(this.enableUniqueValueRenderer, fieldContainerClass),
                this.findParentByClass(this.filterLayer.input, fieldContainerClass),
                this.findParentByClass(this.filterField.input, fieldContainerClass),
                this.findParentByClass(enableResultTable, fieldContainerClass),
                this.findParentByClass(headingNodeResultTable, fieldContainerClass),
                this.findParentByClass(filtersCheckedOnStart, fieldContainerClass),
                this.findParentByClass(resultContainerStyle, fieldContainerClass)
            ];


            var valuesOptions = [
                this.findParentByClass(this.fieldValues.input, fieldContainerClass),
            ];
            var resultOptions = [
                this.findParentByClass(this.resultColumns.input, fieldContainerClass)
            ];
            var manualLayersOptions = [
                this.findParentByClass(this.manualLayers.input, fieldContainerClass)
            ];
            this.setNodeListDisplay(filterOptions, this.enableFilter.checked ? '' : 'none');
            this.updateFilterVisibility = function (forceHidden) {
                this.setNodeListDisplay(filterOptions, (!forceHidden && this.enableFilter.checked) ? '' : 'none');
                this.setNodeListDisplay(resultOptions, (!forceHidden && this.enableFilter.checked && enableResultTable.checked) ? '' : 'none');
                this.setNodeListDisplay(valuesOptions, (!forceHidden && this.enableFilter.checked && !this.enableUniqueValueRenderer.checked) ? '' : 'none');
            };
            $(this.enableFilter).on('change', function() {
                this.updateFilterVisibility(false);
            }.bind(this));
            this.setNodeListDisplay(valuesOptions, (this.enableFilter.checked && !this.enableUniqueValueRenderer.checked) ? '' : 'none');
            $(this.enableUniqueValueRenderer).on('change', function () {
                this.setNodeListDisplay(valuesOptions, (this.enableFilter.checked && !this.enableUniqueValueRenderer.checked) ? '' : 'none');
            }.bind(this));
            this.setNodeListDisplay(resultOptions, (this.enableFilter.checked && enableResultTable.checked) ? '' : 'none');
            $(enableResultTable).on('change', function () {
                this.setNodeListDisplay(resultOptions, (this.enableFilter.checked && enableResultTable.checked) ? '' : 'none');
            }.bind(this));
            this.setNodeListDisplay(manualLayersOptions, enableManualLayers.checked ? '' : 'none');
            $(enableManualLayers).on('change', function () {
                this.setNodeListDisplay(manualLayersOptions, enableManualLayers.checked ? '' : 'none');
            }.bind(this));

            this.initialSettings = this.dumpSettingsObject();
            this.settingsHaveChanged = false;

            // Lizenzcheck
            this.checkAdvancedLicense();
        },
		getSettingsSelect: function(key) {
			var element = document.querySelector('select[name$=\'[' + key + '][vDEF]\']');
			if(!element)
				console.error('Could not find element by key: ' + key);
			return element;
		},
		getSettingsInputProxy: function(key) {
			var element;
			if(this.version7) {
				element = document.querySelector('input[data-formengine-input-name$=\'[' + key + '][vDEF]\']');
			} else {
				element = document.querySelector('input[name$=\'[' + key + '][vDEF]_hr\']');
			}
			if(!element)
				console.error('Could not find element by key: ' + key);
			return element;
		},
		getSettingsCheckbox: function(key) {
			var element = document.querySelector('input[id$=\'[' + key + '][vDEF]_0\']');
			if(!element)
				console.error('Could not find element by key: ' + key);
			return element;
		},
		getSettingsInput: function(key) {
			var element = document.querySelector('input[name$=\'[' + key + '][vDEF]\']');
			if(!element)
				console.error('Could not find element by key: ' + key);
			return element;
		},
		getSettingsTextArea: function(key) {
			var element = document.querySelector('textarea[name$=\'[' + key + '][vDEF]\']');
			if(!element)
				console.error('Could not find element by key: ' + key);
			return element;
		},
        dumpSettingsObject: function () {
            return {
                url: this.backendUrlInput.value != '' ? this.backendUrlInput.value : this.atlasLocationInput.value,
                mapId: this.map.inputProxy.value,
                enableFilter: this.enableFilter.checked,
                filterLayerId: this.filterLayer.inputProxy.value,
                filterField: this.filterField.inputProxy.value,
                enableUniqueValueRenderer: this.enableUniqueValueRenderer.checked
            };
        },
        settingsObjectsMatch: function (a, b) {
            for (var key in a) {
                if (a[key] !== b[key])
                    return false;
            }
            return true;
        },
        updateSettingsHaveChanged: function () {
            if (this.initialSettings && !this.settingsHaveChanged) {
                var settings = this.dumpSettingsObject();
                this.settingsHaveChanged = !this.settingsObjectsMatch(this.initialSettings, settings);
            }
        },
        setNodeListDisplay: function (nodes, display) {
            for (var i = 0; i < nodes.length; i++) {
                nodes[i].style.display = display;
            }
        },
        findParentByClass: function (node, className) {
            while ((node = node.parentElement) && !node.classList.contains(className))
                continue;
            return node;
        },
        createErrorNode: function (parentNode) {
            return utility.createElement('span', {style: {color: 'red'}}, parentNode);
        },
        setupMapSelect: function () {
            this.setupIdSelect(this.map);
            this.map.errorNode = this.createErrorNode(this.map.input.parentElement.parentElement);
            this.updateMapStore();
        },
        setupManualLayersSelect: function () {
            this.manualLayers.input.parentElement.style.display = 'none';
            try {
                this.manualLayers.config = JSON.parse(this.manualLayers.input.textContent);
            } catch (e) {
                this.manualLayers.config = {};
            }
            this.manualLayers.onChange = function () {
                this.manualLayers.input.textContent = JSON.stringify(this.manualLayers.config);
            }.bind(this);
            var destination = this.manualLayers.input.parentElement.parentElement;
            this.manualLayers.domNode = utility.createElement('ul', {'class': 'layerConfig'}, destination);

            // Legende/Hilfestellung zu den Icons
            var legendRoot = utility.createElement('div', {'class': 'layerConfigLegend'}, destination);
            var legendTypeRoot = utility.createElement('div', {}, legendRoot);
            utility.createElement('span', {textContent: 'Layertypen:'}, legendTypeRoot);
            var legendFlagRoot = utility.createElement('div', {}, legendRoot);
            utility.createElement('span', {textContent: 'Zustände:'}, legendFlagRoot);
            var typeNode = utility.createElement('ul', {'class': 'layerConfig'}, legendTypeRoot);
            var flagNode = utility.createElement('ul', {'class': 'layerConfig'}, legendFlagRoot);
            this.createLayerLegendNode(typeNode, 'layerIsGroupIcon', 'Dies ist ein Gruppenlayer', 'Gruppenlayer');
            this.createLayerLegendNode(typeNode, 'layerIsSearchIcon', 'Dies ist ein reiner Suchlayer', 'Reiner Suchlayer');
            this.createLayerLegendNode(typeNode, 'layerIsUvrIcon', 'Dies ist ein Attributtyp-Layer', 'Unique Value Layer');
            this.createLayerLegendNode(typeNode, 'layerIsOtherLayerIcon', 'Dies ist ein sonstiger Layertyp', 'Sonstige Layertypen');
            this.createLayerLegendNode(flagNode, 'layerCheckedIcon showBoth', 'Layer/Wert initial (nicht) auswählen', 'Initial (nicht) auswählen');
            this.createLayerLegendNode(flagNode, 'layerShowAsGroupIcon showBoth', 'Attributtyp-Layer (nicht) als Gruppe darstellen', 'Attributtyp-Layer (nicht) als Gruppe darstellen');
            this.createLayerLegendNode(flagNode, 'layerExpandedIcon showBoth', 'Gruppe initial (nicht) ausklappen', 'Initial ein-/ausklappen');
        },
        createLayerLegendNode: function (parent, iconClass, title, description, breakLine) {
            var node = utility.createElement('li', {}, parent);
            if (breakLine)
                $(node).css('clear', 'both');
            this.createLayerConfigIcon(node, iconClass, title);
            utility.createElement('span', {}, node).textContent = description;
        },
        setupFilterLayerSelect: function () {
            this.setupIdSelect(this.filterLayer);
            this.filterLayer.errorNode = this.createErrorNode(this.filterLayer.input.parentElement.parentElement);
            this.updateLayerStore();
        },
        setupFilterFieldSelect: function () {
            this.setupIdSelect(this.filterField);
            this.filterField.errorNode = this.createErrorNode(this.filterField.input.parentElement.parentElement);
        },
        setupFilterFieldValuesSelect: function () {
            this.setupFilterDragListSelect(this.fieldValues);
            this.updateFieldValueStore();
        },
        setupResultSelect: function () {
            this.setupFilterDragListSelect(this.resultColumns);
        },
        setupIdSelect: function (config) {
			var countries = [];
			$(config.inputProxy.parentElement).addClass('a4IdSelect');
			var element = utility.createElement('input', {
				'class' : this.version7 ? 'form-control' : 'formField tceforms-textfield'
			}, config.inputProxy, 'before');
			
			function showFullAutoComplete() {
				var lookup = config.select.options.lookup;
				if(lookup && !config.select.visible) {
					config.select.stopKillSuggestions();
					config.select.disableKillerFn();
					config.select.suggestions = lookup.slice();
					config.select.suggest();
				}
			}
            $([element, config.inputProxy]).on('keydown keyup', function(e) {
                if (e.keyCode === 13) {
					e.preventDefault();
					e.stopImmediatePropagation();
					
					var that = config.select;
                    if (that.selectedIndex === -1) {
                        that.hide();
                        return;
                    }
                    that.select(that.selectedIndex);
					return false;
                } else if(e.keyCode === 40) {
					showFullAutoComplete();
				}
            });
			
			$(element).autocomplete({
				lookup: countries,
				showNoSuggestionNotice: true,
				autoSelectFirst: true,
				onSelect: function (selected) {
					if(config.selectedItem === selected)
						return;
					config.selectedItem = selected;
                    if (selected) {
                        var id = selected.data.id;
                        config.inputProxy.value = id;
                        config.input.value = id;
                        config.onChange();
                    }
				}
			});
			$(element).click(showFullAutoComplete);
			config.select = $(element).data('autocomplete');

            utility.createElement('span', {innerHTML: ' = '}, element, 'after');

            $(config.inputProxy).on('change', function () {
                this.selectItemFromId(config);
            }.bind(this));

            var del = config.inputProxy.parentElement.querySelector(this.version7 ? 'button.close' : '.t3-icon-input-clear');
            if (del) {
                $(del).on('click', function () {
                    setTimeout(function () {
                        this.selectItemFromId(config);
                    }.bind(this), 100);
                }.bind(this));
            }
        },
        selectItemFromId: function (config) {
            var lookup = config.select.options.lookup;
            if (lookup) {
                var id = config.inputProxy.value;
                for (var i = 0; i < lookup.length; i++) {
                    if (lookup[i].data.id == id) {
						config.select.suggestions = lookup.slice();
                        config.select.select(i);
						config.select.stopKillSuggestions();
                        config.onChange();
                        return;
                    }
                }
            }
            config.inputProxy.value = '';
            config.input.value = '';
			config.select.el.val("");
			config.select.selectedIndex = -1;
            config.onChange();
        },
        updateStore: function (urlSuffix, query, errorNode, callback) {
            this.updateSettingsHaveChanged();
            var url = this.backendUrlInput.value != '' ? this.backendUrlInput.value : this.atlasLocationInput.value;
			
			$.getJSON(url + urlSuffix, $.extend({f: "json"}, query), function (data) {
				callback(data);
				errorNode.textContent = "";
			}).fail(function (error) {
				var message;
				try {
					message = error.response.data.error.message;
				} catch (e) {
					message = error.message;
				}
				errorNode.textContent = "Fehler: Anfrage fehlerhaft! Bitte überprüfen Sie die Einstellungen.";
			});
        },
        updateMapStore: function () {
            this.errorNode.textContent = '';
            this.updateStore('/spring/rest/maps', {}, this.errorNode, function (data) {
                // ATLAS-5066: nur veröffentlichte Karten zeigen
                var publishedMaps = [];
                for (var i = 0; i < data.length; i++) {
					var map = data[i];
                    if (map.published) {
                        publishedMaps.push({
							value: map.name,
							data: {
								id: map.id
							}
						});
                    }
                }
                this.map.select.options.lookup = publishedMaps.sort(sortByValueKey);
                this.selectItemFromId(this.map);
            }.bind(this));
            // Lizenzcheck
            if(this.initialSettings)
                this.checkAdvancedLicense();
        },
        disableAdvancedFunctions: function () {
            if (this.enableFilter.checked)
                this.updateFilterVisibility(true);
            
            this.enableFilter.disabled = 1;
            if(!this.licenseNotice) {
                this.licenseNotice = utility.createElement('div', {
                    style: {color: 'red'},
                    innerHTML: 'Erweiterte Einstellungen benötigen ein Lizenz-Upgrade.<br>' +
                            '<a target="_blank" href="http://www.alta4.com/webmapping/atlasfx.html">(Weitere Informationen zum Produkt finden Sie bei alta4.)</a>'

                }, this.enableFilter, 'after');
            }
        },
        enableAdvancedFunctions: function() {
            if(this.licenseNotice) {
                $(this.licenseNotice).remove();
                this.licenseNotice = null;
                delete this.enableFilter.disabled;
                $(this.enableFilter).prop('disabled', false);
                this.updateFilterVisibility(false);
			}
        },
        checkAdvancedLicense: function () {
            var url = this.backendUrlInput.value != '' ? this.backendUrlInput.value : this.atlasLocationInput.value;
            this.disableAdvancedFunctions();
			$.getJSON(url + "/spring/rest/license/products/ATLASFX_TYPO3_MAP_FILTER_PLUGIN", function (response) {
				if (this.enableFilter && !response.isLicensed) {
					this.disableAdvancedFunctions();
				} else {
					this.enableAdvancedFunctions();
				}
			}.bind(this)).fail(this.disableAdvancedFunctions.bind(this));
        },
        addLayer: function (layer, layerArray) {
            if (layer.type == "GroupLayer") {
                for (var i = 0; i < layer.children.length; i++) {
                    this.addLayer(layer.children[i], layerArray);
                }
            } else if (layer.datasource) {
                var fields = [];
                if (layer.datasource.fields) {
                    for (var j = 0; j < layer.datasource.fields.length; j++) {
                        var field = layer.datasource.fields[j];
                        field.id = field.name;
						fields.push({
							value: field.name,
							data: {
								id: field.id,
								name: field.name
							}
						});
                    }
                }
                layerArray.push({
					value: layer.name,
					data: {
						id: layer.id,
						fields: fields,
						raw: layer
					}
				});
            }
        },
        updateLayerStore: function () {
            var mapId = this.map.inputProxy.value;
            if (mapId == '') {
                this.map.errorNode.textContent = "Fehler: Map ID wurde nicht gesetzt!";
                return;
            }
            this.map.errorNode.textContent = "";
            this.updateStore('/spring/rest/maps/' + mapId, {}, this.map.errorNode, function (data) {
                var layers = [];
                for (var i = 0; i < data.layers.length; i++) {
                    this.addLayer(data.layers[i], layers);
                }
                this.filterLayer.select.options.lookup = layers.sort(sortByValueKey);
                this.selectItemFromId(this.filterLayer);

                this.createManualLayersConfig(data.layers);
            }.bind(this));
        },
        updateFieldValueStore: function () {
            var field = this.filterField.inputProxy.value;
            if (field == '') {
                this.filterField.errorNode.textContent = "Fehler: Filter Feld wurde nicht gesetzt!";
				this.fieldValues.dragList.updateDoubleList([], []);
                this.fieldValues.onChange();
                return;
            }
            var selected = this.filterLayer.selectedItem;
			var layer = selected && selected.data.raw;
            if (!layer) {
                this.filterField.errorNode.textContent = "Fehler: Layer wurde nicht gesetzt!";
                return;
            }
            this.filterField.errorNode.textContent = "";
            var hasUniqueValueRenderer = !!(layer.styling)
                    && layer.styling.type === 'uniqueValue'
                    && layer.styling.field1 === field;
            var uniqueValueKeys;
            if (hasUniqueValueRenderer) {
                uniqueValueKeys = {};
                var uvi = layer.styling.uniqueValueInfos;
                for (var i = 0; i < uvi.length; i++) {
                    if (uvi[i].selected || uvi[i].tocVisibility)
                        uniqueValueKeys[uvi[i].value] = true;
                }
            }

            var query = {outFields: field, returnDistinctValues: true, outSR: 102100};
            this.updateStore('/spring/rest/MapServer/' + layer.id + '/query', query, this.filterLayer.errorNode, function (data) {
				var allIds = [];
				var selectedItems = [];
                var previousItemMap = this.fieldValues.itemMap;
                var previousItems = this.fieldValues.items;
                for (var i = 0; i < data.features.length; i++) {
                    var value = data.features[i].attributes[field];
                    if (!hasUniqueValueRenderer || uniqueValueKeys.hasOwnProperty(value)) {
                        if (previousItemMap.hasOwnProperty(value)) {
                            var index = previousItemMap[value];
							var item = $.extend({}, previousItems[index]);
							item._position = index;
							selectedItems.push(item);
                        }
						allIds.push(value);
                    }
                }

                selectedItems.sort(function (a, b) {
                    return a._position - b._position;
                });
                for (var i = 0; i < selectedItems.length; i++)
					delete selectedItems[i]._position;

				this.fieldValues.dragList.updateDoubleList(selectedItems, allIds);
                this.fieldValues.onChange();
            }.bind(this));

            var enabled = hasUniqueValueRenderer;
            if (hasUniqueValueRenderer && !this.settingsHaveChanged) {
                enabled = this.initialSettings.enableUniqueValueRenderer;
            }
            delete this.enableUniqueValueRenderer.disabled;
            $(this.enableUniqueValueRenderer).prop('disabled', false);
            if (this.enableUniqueValueRenderer.checked !== enabled) {
                this.enableUniqueValueRenderer.click();
            }
            if (!hasUniqueValueRenderer) {
                $(this.enableUniqueValueRenderer).prop('disabled', true);
            }
        },
        updateResultColumns: function (fields) {
			var allIds = [];
			var selectedItems = [];
            var previousItemMap = this.resultColumns.itemMap;
            var previousItems = this.resultColumns.items;
            for (var i = 0; i < fields.length; i++) {
                var field = fields[i];
				var name = field.data.name;
                if (previousItemMap.hasOwnProperty(name)) {
                    var index = previousItemMap[name];
					var item = $.extend({}, previousItems[index]);
					item._position = index;
					selectedItems.push(item);
                }
				allIds.push(name);
            }

            selectedItems.sort(function (a, b) {
                return a._position - b._position;
            });
			for (var i = 0; i < selectedItems.length; i++)
				delete selectedItems[i]._position;

			this.resultColumns.dragList.updateDoubleList(selectedItems, allIds);
            this.resultColumns.onChange();
        },
        onMapChange: function () {
            this.updateLayerStore();
        },
        onFilterLayerChange: function () {
            this.updateSettingsHaveChanged();
            var layer = this.filterLayer.selectedItem;
            if (layer) {
                this.filterLayer.errorNode.textContent = "";
                var fields = layer.data.fields;
                this.filterField.select.options.lookup = fields.sort(sortByValueKey);
                this.selectItemFromId(this.filterField);
                this.updateResultColumns(fields);
            } else {
                this.filterLayer.errorNode.textContent = "Fehler: Filter Layer wurde nicht gesetzt!";
            }
        },
        onFilterFieldChange: function () {
            this.updateFieldValueStore();
        },
        makePseudoLayerId: function (layerId, value) {
            // Maskierung wegen Verwendung in punktseparierter Liste und Layer-Wert-Separator
            if (typeof value === 'string') {
                value = value.replace(/[\.!]/g, '_');
            }
            return layerId + '!' + value;
        },
        getOrCreatePseudoLayerConfig: function (uviv, uniqueValueInfos) {
            var config = uniqueValueInfos[uviv.value] || {};
            if (!config.hasOwnProperty('include'))
                config.include = false;
            if (!config.hasOwnProperty('checked'))
                config.checked = false;
            config.showInToc = uviv.tocVisibility;
            if(!config.showInToc)
                config.checked = config.include;
            if(!config.hasOwnProperty('label'))
                config.label = '';
            return config;
        },
        getOrCreateLayerConfig: function (layer, configs) {
            var config = configs[layer.id] || {};
            if (!config.hasOwnProperty('include'))
                config.include = false;
            if (!config.hasOwnProperty('expanded'))
                config.expanded = layer.isOpenOnStart;
            if (!config.hasOwnProperty('checked'))
                config.checked = layer.selected;
            if (layer.styling && layer.styling.type === 'uniqueValue') {
                if (!config.hasOwnProperty('showAsGroup'))
                    config.showAsGroup = !layer.styling.isNotGroup;
                if (!config.hasOwnProperty('uniqueValueInfos'))
                    config.uniqueValueInfos = {};
            }
            if (layer.children && !config.hasOwnProperty('children'))
                config.children = {};
            if (!config.label)
                config.label = "";
            return config;
        },
        createLayerConfigCheckbox: function (node, id, prefix, checked, title, onChange, noIcon) {
            var prefixedId = prefix + '_' + id;
            var input = utility.createElement('input', {'type': 'checkbox', 'class': prefix, id: prefixedId, name: prefixedId, checked: checked}, node);
            if (!noIcon) {
                input.style.display = 'none';
                utility.createElement('label', {'class': prefix + 'Icon', 'for': prefixedId, title: title}, node);
            } else {
                input.title = title;
            }
            $(input).on('click', onChange);
            return input;
        },
        createLayerConfigIcon: function (node, iconClass, title) {
            utility.createElement('label', {'class': iconClass, title: title}, node);
        },
        createLayerConfigNode: function (parent, id, name, config, onChange, typeIcon) {
            var node = utility.createElement('li', {}, parent);
            function localOnChange() {
                config.include = layerInclude.checked;
                if (layerChecked) {
                    if(!config.showInToc && typeIcon === 'value')
                        config.checked = config.include;
                    else
                        config.checked = layerChecked.checked;
                }
                if (layerShowAsGroup)
                    config.showAsGroup = layerShowAsGroup.checked;
                if (layerExpanded)
                    config.expanded = layerExpanded.checked;
                config.label = label.value;
                onChange();
            }

            var layerInclude = this.createLayerConfigCheckbox(node, id, 'layerInclude', config.include, 'Layer hinzufügen', localOnChange, true);
            if (typeIcon === 'group')
                this.createLayerConfigIcon(node, 'layerIsGroupIcon', 'Dies ist ein Gruppenlayer');
            else if (typeIcon === 'search')
                this.createLayerConfigIcon(node, 'layerIsSearchIcon', 'Dies ist ein reiner Suchlayer');
            else if (typeIcon === 'uvr')
                this.createLayerConfigIcon(node, 'layerIsUvrIcon', 'Dies ist ein Attributtyp-Layer');
            else if (typeIcon === 'layer' || typeIcon === 'value')
                this.createLayerConfigIcon(node, 'layerIsOtherLayerIcon', 'Dies ist ein sonstiger Layertyp');
            if (typeIcon === 'uvr')
                var layerShowAsGroup = this.createLayerConfigCheckbox(node, id, 'layerShowAsGroup', config.showAsGroup, 'Klicken um Attributtyp-Layer (nicht) als Gruppe darzustellen', localOnChange);
            if (typeIcon === 'uvr' || typeIcon === 'group')
                var layerExpanded = this.createLayerConfigCheckbox(node, id, 'layerExpanded', config.expanded, 'Klicken um Gruppe initial ein-/auszuklappen', localOnChange);
            if (typeIcon !== 'uvr' && typeIcon !== 'group')
                var layerChecked = this.createLayerConfigCheckbox(node, id, 'layerChecked', config.checked, 'Klicken um Layer initial (nicht) auszuwählen', localOnChange);
            utility.createElement('span', {}, node).textContent = name + ':';
            var label = utility.createElement('input', {type: 'text', title: 'Manuelle Bezeichnung falls gewünscht.', placeholder: name}, node);
            if (config.label)
                label.value = config.label;
            $(label).on('change', localOnChange);
            return node;
        },
        createLayerConfigNodeTree: function (parent, layer, config, onChange) {
            var node, childrenNode;
            if (layer.children) {
                node = this.createLayerConfigNode(parent, layer.id, layer.name, config, onChange, 'group');
                if (layer.children) {
                    childrenNode = utility.createElement('ul', {'class': 'layerConfig'}, node);
                    var children = {};
                    for (var i = 0; i < layer.children.length; i++) {
                        var child = layer.children[i];
                        var childConfig = this.getOrCreateLayerConfig(child, config.children);
                        this.createLayerConfigNodeTree(childrenNode, child, childConfig, onChange);
                        children[child.id] = childConfig;
                    }
                    config.children = children;
                }
            } else if (layer.styling && layer.styling.type === 'uniqueValue') {

                // Vgl. createUVPseudoLayerConfig() in Toc.js

                var uniqueValueInfos = {};
                node = this.createLayerConfigNode(parent, layer.id, layer.name, config, onChange, 'uvr');
                childrenNode = utility.createElement('ul', {'class': 'layerConfig'}, node);

                var uvi = layer.styling.uniqueValueInfos;
                var displayOthersValuesInToc = false;
                // Feststellen ob "Sonstige" vorhanden sind
                for (var i = 0; i < uvi.length; i++) {
                    var uviv = uvi[i];
                    if (!uviv.tocVisibility && uviv.selected) {
                        displayOthersValuesInToc = true;
                        break;
                    }
                }
                if (layer.styling.defaultTocVisibility && displayOthersValuesInToc) {
                    var pseudoId = 'othersValue';
                    var defaultLabel = layer.styling.defaultLabel;
                    var pseudoConfig = this.getOrCreatePseudoLayerConfig({
                        value: pseudoId,
                        label: defaultLabel,
                        selected: layer.styling.defaultSelected,
                        tocVisibility: true
                    }, config.uniqueValueInfos);
                    this.createLayerConfigNode(childrenNode, pseudoId, defaultLabel, pseudoConfig, onChange, 'value');
                    uniqueValueInfos[pseudoId] = pseudoConfig;
                }
                for (var i = 0; i < uvi.length; i++) {
                    var uviv = uvi[i];
                    if (uviv.tocVisibility) {
                        var pseudoId = this.makePseudoLayerId(layer.id, uviv.value);
                        var pseudoConfig = this.getOrCreatePseudoLayerConfig(uviv, config.uniqueValueInfos);
                        this.createLayerConfigNode(childrenNode, pseudoId, uviv.label, pseudoConfig, onChange, 'value');
                        uniqueValueInfos[uviv.value] = pseudoConfig;
                    }
                }
                config.uniqueValueInfos = uniqueValueInfos;
            } else {
                var typeIcon = (!layer.alwaysVisible && !layer.visible) ? 'search' : 'layer';
                this.createLayerConfigNode(parent, layer.id, layer.name, config, onChange, typeIcon);
            }
        },
        createManualLayersConfig: function (layers) {
            var storage = {};
            var oldStorage = this.manualLayers.config || {};
            var parent = this.manualLayers.domNode;
            var onChange = this.manualLayers.onChange;

            parent.innerHTML = '';
            for (var i = 0; i < layers.length; i++) {
                var layer = layers[i];
                var config = this.getOrCreateLayerConfig(layer, oldStorage);
                this.createLayerConfigNodeTree(parent, layer, config, onChange);
                storage[layer.id] = config;
            }
            this.manualLayers.config = storage;
            onChange();
        },
        setupFilterDragListSelect: function (config) {
            var items;
            try {
                items = JSON.parse(config.input.textContent);
            } catch (e) {
            }
            config.items = $.isArray(items) ? items : [];
            config.itemMap = {};
			for (var i = 0; i < config.items.length; i++) {
				var item = config.items[i];
				config.itemMap[item.key] = i;
			}

            config.input.parentElement.style.display = 'none';
			
			config.onChange = function () {
                // update json
                config.items = config.dragList.getData();
                config.itemMap = {};
                for (var i = 0; i < config.items.length; i++) {
                    var item = config.items[i];
					config.itemMap[item.key] = i;
                }
                config.input.textContent = JSON.stringify(config.items);
                if (config.items.length == 0 && !config.allowEmpty)
                    config.errorNode.textContent = "Fehler: Kein Eintrag ausgewählt";
                else
                    config.errorNode.textContent = "";
            }.bind(this);
			
			function dataFactory(id) {
				return {
					key: id,
					text: id
				};
			};
			var allIds = [];
			var destination = config.input.parentElement.parentElement;
			config.dragList = new DragList({
				parentElement: destination,
				items: config.items,
				onChange: config.onChange,
				NodeClass: DragListNodeLabeledValue,
				extraParam: {
					hasWidth: config.hasWidth,
					onChange: config.onChange
				},
				labelFormatter: null,
				doubleList: true,
				allIds: allIds,
				dataFactory: dataFactory,
				labelPossible: config.possibleText,
				labelChosen: config.selectedText
			});

            config.errorNode = this.createErrorNode(destination);
        }
    });
});