define(["exports", "jquery"], function (exports, $) {
	$.extend(exports, {
		createClass: function(ClassParent, definition) {
			var parentClasses = [];
			var classParentIterator = ClassParent;
			while(classParentIterator) {
				parentClasses.push(classParentIterator);
				classParentIterator = classParentIterator.prototype.inherited;
			}
			parentClasses.reverse();

			function TheClass() {
				for(var i=0; i<parentClasses.length; i++) {
					var constructor = parentClasses[i].prototype.classDefinition.constructor;
					if(constructor)
						constructor.apply(this, arguments);
				}
				if(definition.constructor)
					definition.constructor.apply(this, arguments);
			}
			if(ClassParent)
				$.extend(TheClass.prototype, ClassParent.prototype);
			$.extend(TheClass.prototype, definition);
			// make sure constructor stays the same
			TheClass.prototype.constructor = TheClass;

			if(ClassParent)
				TheClass.prototype.inherited = ClassParent.prototype;
			TheClass.prototype.classDefinition = definition;
			return TheClass;
		},
		createElement: function(tagName, attributes, refNode, refPos) {
			var element = $('<' + tagName + '>');
			if(attributes) {
				if(attributes.style) {
					element.css(attributes.style);
					delete attributes.style;
				}
				if(attributes['class']) {
					element.addClass(attributes['class']);
					delete attributes['class'];
				}
				element.prop(attributes);
			}
			
			if(refNode)
				this.placeElement(element.get(0), refNode, refPos);
			return element.get(0);
		},
		placeElement: function(element, refNode, refPos) {
			if(refPos === 'after')
				$(element).insertAfter(refNode);
			else if(refPos === 'before')
				$(element).insertBefore(refNode);
			else if(refPos === 'first')
				$(refNode).prepend(element);
			else
				$(refNode).append(element);
		}
	});
});
