define(["../Utility",
	"./DragListNode",
	"jquery"
], function (
		utility,
		DragListNode,
		$) {
	return utility.createClass(DragListNode, {
		constructor: function (data, labelFormatter, extraParam) {
            var label = utility.createElement('input', {type: 'text', class: 'labelInput'}, this.domNode);
            if(data.text)
                label.value = data.text;
			var width = null;
			if(extraParam.hasWidth) {
				var width = utility.createElement('input', {type: 'text', class: 'widthInput', placeholder: 'auto'}, this.domNode);
				if(data.width)
					width.value = data.width;
				utility.createElement('span', {textContent: ' px'}, this.domNode);
			}
            if (extraParam.onChange) {
                $(label).on('change', function() {
					this.data.text = label.value;
					extraParam.onChange();
				}.bind(this));
				if(width) {
					$(width).on('change', function() {
						this.data.width = width.value;
						extraParam.onChange();
					}.bind(this));
				}
			}
		},
		getId: function() {
			return this.data.key;
		}
	});
});
