<?php

/* * *************************************************************
 *  Copyright notice
 *
 *  (c) 2010  <bpaulsen>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 * ************************************************************* */
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 * Hint: use extdeveval to insert/update function index above.
 */

/**
 * Class that adds the wizard icon.
 *
 * @author     <bpaulsen>
 * @package    TYPO3
 * @subpackage    tx_alta4atlasfx
 */
class tx_alta4atlasfx_pi1_wizicon {

    /**
     * Processing the wizard items array
     *
     * @param    array        $wizardItems: The wizard items
     * @return    Modified array with wizard items
     */
    function proc($wizardItems) {
        global $LANG;
		a4RequireUtils();

        $LL = $this->includeLocalLang();

        $wizardItems['plugins_tx_alta4atlasfx_pi1'] = array(
            'icon' => \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extRelPath('alta4_atlasfx') . 'pi1/ce_wiz.gif',
            'title' => 'atlasFX Kartenplugin',
            'description' => 'Das atlasFX Typo3 Kartenplugin',
            'params' => '&defVals[tt_content][CType]=list&defVals[tt_content][list_type]=alta4_atlasfx_pi1'
        );

        return $wizardItems;
    }

    /**
     * Reads the [extDir]/locallang.xml and returns the $LOCAL_LANG array found in that file.
     *
     * @return    The array with language labels
     */
    function includeLocalLang() {
        if(!class_exists('\\TYPO3\\CMS\\Core\\Utility\\GeneralUtility')) {
            $llFile = t3lib_extMgm::extPath('alta4_atlasfx') . 'locallang.xml';
            if (class_exists('t3lib_l10n_parser_Llxml')) {
                $object = t3lib_div::makeInstance('t3lib_l10n_parser_Llxml');
                $LOCAL_LANG = $object->getParsedData($llFile, $GLOBALS['LANG']->lang);
            } else {
                $LOCAL_LANG = t3lib_div::readLLXMLfile($llFile, $GLOBALS['LANG']->lang);
            }
        } else {
			a4RequireUtils();
            $LOCAL_LANG = \TYPO3\CMS\Core\Utility\GeneralUtility::readLLfile(\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath('alta4_atlasfx') . 'locallang.xml', $GLOBALS['LANG']->lang);
        }
        return $LOCAL_LANG;
    }

}


if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/alta4_atlasfx/pi1/wizicon.php']) {
    include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/alta4_atlasfx/pi1/wizicon.php']);
}
